import gcode2contour as gc
import numpy as np
from openravepy import *

####### HACKY WAY
import sys, os
sys.path.append(os.path.join(os.path.dirname(__file__), '..', 'utils'))
from openrave_utils import *
######## END HACK

def _dist(p1, p2):
    return ((p1[0]-p2[0])**2 + (p1[1]-p2[1])**2 + (p1[2]-p2[2])**2)**0.5


def _linspace(contour, d):
    new_pos = []
    new_time = []
    for i in range(len(contour.time)-1):
        
        # number of intervals
        n = max(2,int(_dist(contour.pos[i], contour.pos[i+1])/d))

        # linspace
        new_time = new_time + np.linspace(contour.time[i], contour.time[i+1],n).tolist()

        X = np.linspace(contour.pos[i][0], contour.pos[i+1][0], n).tolist()
        Y = np.linspace(contour.pos[i][1], contour.pos[i+1][1], n).tolist()
        Z = np.linspace(contour.pos[i][2], contour.pos[i+1][2], n).tolist()

        new_pos = new_pos + [(x,y,z) for x,y,z in zip(X,Y,Z)]

    contour.time = new_time
    contour.pos = new_pos
    return contour



# TEST CASE 1: IK WITH 1 SOLUTION
# CONTOUR 1: [(-0.3, 0, 0), (-0.1,  0.2, 0), ( 0.1, 0, 0)]
# CONTOUR 2: [( 0.3, 0, 0), ( 0.1, -0.2, 0), (-0.1, 0, 0)]
# TIME: [0,2,4]
contourIK1 = gc.contour( [(0,-0.3,0), (0.2,-0.1,0), (0,0.1,0)], 0)
contourIK1.time = [0,2,4]
contourIK1 = _linspace(contourIK1, 0.01)

contourIK2 = gc.contour( [(0,0.3,0), (-0.2,0.1,0), (0,-0.1,0)], 0)
contourIK2.time = [0,2,4]
contourIK2 = _linspace(contourIK2, 0.01)

def test_case1(env):
    env.SetViewer("qtcoin")
    show_contour(contourIK1, env)
    show_contour(contourIK2, env)
